#include <vector>
#include <string>
#include <sstream>
#include "ct11pdf.h"

double calcWerror(double mW, double sqrts, int nEvent){

  // Read the pdf-tables for the central and error sets.
  string cteqSet = "ctq66.";
  string pdfType = ".pds";
  vector<cteqpdf> pdfSets;
  int nErrorSets = 44;
  for(int i = 0; i < nErrorSets+1;++i){
    stringstream filess;
    filess << cteqSet;
    if(i < 10) filess << 0;
    filess << i << pdfType;
    string file = filess.str();
    cteqpdf pdfSet;
    pdfSet.setct11(file);
    pdfSets.push_back(pdfSet);
  }

  // Example:
  double x = mW/sqrts;
  cout << "PDF test:" << endl;
  // NOTICE: in CTEQ PDFs i=1 is up quark and i=2 down quark unlike in PYTHIA
  cout << "up quark PDF at x = " << x << " and Q = " << mW << endl;
  cout << pdfSets[0].parton(1,x,mW) << endl;
  cout << "anti-d quark PDF at x = " << x << " and Q = " << mW << endl;
  cout << pdfSets[0].parton(-2,x,mW) << endl;

  return 0;
}

int main() {

  int nEvent = 10000;
  double mW = 80;
  double sqrts = 8000;
  cout << calcWerror(mW, sqrts, nEvent) << endl;

  return 0;
}
